<template>
  <div class="m-cards__item">
    <div class="m-cards__top">
      <router-link
        tag="div"
        :to="{
          name: 'murren',
          params: { murren_name: this.card.owner_name },
        }"
        class="m-cards__author"
      >
<!--        <div-->
<!--          class="m-cards__author-avatar"-->
<!--          :style="{ backgroundImage: `url(${card.owner_avatar})` }"-->
<!--        />-->
                    <img :src="card.owner_avatar" alt=""
                         class="m-cards__author-avatar"
                 onerror="this.src='http://murrengan.ru/murr-back/media/profile/default_murren_avatar.png'"
            />
        <div class="m-cards__author-name" v-text="card.owner_name" />
        <span class="m-cards__new-murr" v-if="isUnreaded"></span>
      </router-link>
      <!-- .m-cards__author -->

      <div class="m-cards__actions">
        <el-button
          v-if="isContentFilled"
          type="text"
          icon="el-icon-document m-cards__document-icon"
          class="m-cards__document-button"
        />

        <el-button
          @click="onOpenMorePopup"
          type="text"
          icon="el-icon-more-outline m-cards__more-icon"
          class="m-cards__more-button"
        />

        <transition name="el-zoom-in-top">
          <murr-card-more-popup
            v-if="openedMore"
            :isAuthorized="isMurrenAuthorized"
            :isSubscriber="card.is_subscriber"
            :isAuthorMurr="isAuthorMurr"
            @copy-link="onCopyMurrLink"
            @subscribe="onSubscribeToMurren"
            v-click-outside="onCloseMorePopup"
          />
        </transition>
      </div>
    </div>
    <!-- .m-cards__top -->

    <div v-if="card.cover" @click="onOpenMurrCard" class="m-cards__cover">
      <img :src="card.cover" :alt="card.title" class="m-cards__cover-img" />
    </div>
    <!-- .m-cards__cover -->

    <div @click="onOpenMurrCard" v-text="card.title" class="m-cards__title" />
    <!-- .m-cards__title -->

    <div class="m-cards__footer">
      <div class="m-cards__rating">
        <el-button
          icon="el-icon-arrow-up"
          type="text"
          :class="{
            'm-cards__rating-like': true,
            is_like: card.is_like,
          }"
          @click="onRatingLike"
        />

        <el-button
          type="text"
          class="m-cards__rating-counter"
          :class="{
            positive: card.rating > 0,
            negative: card.rating < 0,
          }"
        >
          {{ card.rating }}
        </el-button>
        <el-button
          icon="el-icon-arrow-down"
          type="text"
          :class="{
            'm-cards__rating-unlike': true,
            is_dislike: card.is_dislike,
          }"
          @click="onRatingUnlike"
        />
      </div>
      <div class="m-cards__comments" v-if="card.comments_count">
        <el-button
          v-if="card.comments_count != 0"
          icon="el-icon-chat-round"
          type="text"
          class="m-cards__comments-btn"
          @click="onOpenMurrCard"
        >
          <span class="m-cards__comments-count">
            {{ +card.comments_count >= 100 ? "99+" : card.comments_count }}
          </span>
        </el-button>
      </div>
    </div>
    <!-- .m-cards__footer -->
    <read-murr-card
      v-if="isUnreaded"
      :murrId="card.id"
      :key="'read-murr-' + card.id"
    />
  </div>
</template>

<script>
import { mapActions } from "vuex";
import MurrCardDetail from "./MurrCardDetail.vue";
import MurrCardMorePopup from "./MurrCardMorePopup.vue";
import ReadMurrCard from "../notification/ReadMurrCard.vue";
import * as type from "./store/type.js";
import { MURREN_SUBSCRIBE } from "../murren/store/type.js";

import { copyToBuffer } from "../../utils/helpres.js";

export default {
  name: "MurrCardItem",

  components: {
    MurrCardMorePopup,
    ReadMurrCard,
  },

  data: () => ({
    openedMore: false,
  }),

  props: {
    card: {
      type: Object,
      required: true,
    },
    isMurrenAuthorized: {
      type: Boolean,
      required: true,
    },
    targetPage: String,
  },

  computed: {
    isAuthorMurr() {
      return this.card.owner === this.$store.getters.currentMurren?.id;
    },
    isUnreaded() {
      return this.$store.getters.murrCardNotices.indexOf(this.card.id) !== -1;
    },
    isContentFilled() {
      return !!this.card.content;
    },
  },

  methods: {
    ...mapActions({
      notification: "popUpMessage",
      handlerSignInModal: "changeShowLoginForm_actions",
    }),

    notAuthenticatedRatingNotification() {
      this.notification({
        message: `Залогинься и сможешь оценивать`,
        type: "success",
      });

      this.handlerSignInModal();
    },

    async ratingAction(action) {
      const { success, data } = await this.$store.dispatch(action, {
        murrID: this.card.id,
      });

      if (success) {
        this.card.rating = data.rating;
        this.card.is_like = data.is_like;
        this.card.is_dislike = data.is_dislike;
        if (this.targetPage === "myLikes") {
          this.$store.commit(type.MURR_CARDS_REMOVE, this.card.id);
        }
      }
    },

    async onRatingLike() {
      if (!this.isMurrenAuthorized) {
        this.notAuthenticatedRatingNotification();
        return;
      }

      await this.ratingAction(type.MURR_CARD_LIKED);
    },

    async onRatingUnlike() {
      if (!this.isMurrenAuthorized) {
        this.notAuthenticatedRatingNotification();
        return;
      }

      await this.ratingAction(type.MURR_CARD_UNLIKED);
    },

    onOpenMurrCard() {
      this.$store.commit("modal/open", {
        transition: "el-zoom-in-top",
        component: {
          render: MurrCardDetail,
          props: {
            murrCardId: this.card.id,
          },
        },
      });
    },

    onOpenMurrenProfile() {
      this.$router.push({
        name: "murren",
        params: { murren_name: this.card.owner_name },
      });
    },

    murrCardLink() {
      const protocol = window.location.protocol;
      const host = window.location.host;
      return `${protocol}//${host}/murr_card/${this.card.id}`;
    },

    onCopyMurrLink() {
      this.onCloseMorePopup();

      const murrCardLink = this.murrCardLink();
      copyToBuffer(murrCardLink);

      this.notification({
        message: `Линка на мурр скопирована 😊`,
        type: "success",
      });
    },

    async onSubscribeToMurren() {
      this.onCloseMorePopup();

      const { success, data } = await this.$store.dispatch(MURREN_SUBSCRIBE, {
        username: this.card.owner_name,
      });

      if (success) {
        let targetPage = this.$parent.$parent.$props.targetPage;
        if (targetPage === "subscription")
          this.$store.commit(type.CLEAR_SUBSCRIBE_CARDS, this.card.owner);
        let message;

        this.$store.commit(type.MURR_CARDS_CHANGE_SUBSCRIBER_STATUS, {
          murrenID: this.card.owner,
          isSubscriber: data.is_subscriber,
        });

        if (data.is_subscriber) {
          message = `Вы успешно подписались на ${this.card.owner_name} 😊`;
        } else {
          message = `Вы успешно отписались от ${this.card.owner_name} 😟`;
        }

        this.notification({
          message: message,
          type: "success",
        });
      }
    },

    onOpenMorePopup() {
      this.openedMore = true;
    },

    onCloseMorePopup() {
      this.openedMore = false;
    },
  },
};
</script>
